commit 8723299ad1dac8a041656d1dcfed273dc2956daa
Author: freddy77 <freddy77>
Date:   Wed Oct 22 20:16:11 2008 +0000

    support conversions from wire to SQL_C_WCHAR

diff --git a/ChangeLog b/ChangeLog
index 4ca610c..430e3d0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Oct 22 22:15:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/odbc/unittests/data.c:
+	- support conversions from wire to SQL_C_WCHAR
+
 Mon Oct 22 17:21:18 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c src/odbc/unittests/data.c:
 	- initial SQL_C_WCHAR support
@@ -735,4 +739,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2630 2008/10/22 15:22:59 freddy77 Exp $
+$Id: ChangeLog,v 1.2631 2008/10/22 20:16:11 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 1dd8bc3..34894dd 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -40,7 +40,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.56 2008/10/17 08:56:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.57 2008/10/22 20:16:11 freddy77 Exp $");
 
 #if SIZEOF_SQLWCHAR == 2
 # if WORDS_BIGENDIAN
@@ -184,10 +184,9 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		}
 	}
 
-	/*
-	 * TODO support SQL_C_WCHAR converting when needed
-	 */
-	if (desttype == SQL_C_CHAR) {
+	if (desttype == SQL_C_WCHAR)
+		destlen /= sizeof(SQLWCHAR);
+	if (desttype == SQL_C_CHAR || desttype == SQL_C_WCHAR) {
 		switch (srctype) {
 		case SYBLONGBINARY:
 		case SYBBINARY:
@@ -205,7 +204,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		ores.cc.c = dest;
 	}
 
-	if (desttype == SQL_C_CHAR && (srctype == SYBDATETIME || srctype == SYBDATETIME4)) {
+	if ((desttype == SQL_C_CHAR || desttype == SQL_C_WCHAR) && (srctype == SYBDATETIME || srctype == SYBDATETIME4)) {
 		char buf[40];
 		TDSDATEREC when;
 
@@ -249,6 +248,36 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		}
 		break;
 
+	case SQL_C_WCHAR:
+		tdsdump_log(TDS_DBG_FUNC, "odbc_tds2sql: outputting character data destlen = %lu \n", (unsigned long) destlen);
+
+		ret = nRetVal * sizeof(SQLWCHAR);
+		/* TODO handle not terminated configuration */
+		if (destlen > 0) {
+			SQLWCHAR *wp = (SQLWCHAR *) dest;
+			SQLCHAR  *p  = (SQLCHAR *)  dest;
+
+			cplen = (destlen - 1) > nRetVal ? nRetVal : (destlen - 1);
+			assert(cplen >= 0);
+			/*
+			 * odbc always terminate but do not overwrite 
+			 * destination buffer more than needed
+			 */
+			/* TODO check for source !!! */
+			if (curcol)
+				curcol->column_text_sqlgetdatapos += binary_conversion ? cplen / 2 : cplen;
+			wp[cplen] = 0;
+			for (;cplen > 0;) {
+				--cplen;
+				wp[cplen] = p[cplen];
+			}
+		} else {
+			/* if destlen == 0 we return only length */
+			if (destlen != 0)
+				ret = SQL_NULL_DATA;
+		}
+		break;
+
 	case SQL_C_TYPE_DATE:
 	case SQL_C_DATE:
 
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 5aaf532..78dbd75 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.20 2008/10/22 15:22:59 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.21 2008/10/22 20:16:11 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -138,6 +138,8 @@ main(int argc, char *argv[])
 		}
 	}
 
+	Test("INT", "-123", SQL_C_CHAR, "4 -123");
+	Test("INT", "78654", SQL_C_WCHAR, "5 78654");
 	if (db_is_microsoft() && (strncmp(version, "08.00.", 6) == 0 || strncmp(version, "09.00.", 6) == 0)) {
 		/* nvarchar without extended characters */
 		Test("NVARCHAR(20)", "test", SQL_C_CHAR, "4 test");
@@ -148,6 +150,7 @@ main(int argc, char *argv[])
 		/* nvarchar with extended characters */
 		Test("NVARCHAR(20)", "0x830068006900f200", SQL_C_WCHAR, "4 \x83hi\xf2");
 		Test("NVARCHAR(20)", "0xA406A5FB", SQL_C_WCHAR, "2 \\u06a4\\ufba5");
+		/* TODO NVARCHAR -> SQL_C_LONG */
 	}
 
 	/* case (1) */

